/************************************************************************
 *																								*
 *   DEMO.C	This is a small demo of the object files called from a		*
 *		user program. I did it on my Borland TurboC compiler					*
 *		but as you can see from the first three routines all I				*
 *		have done is map straight into assembler and call a far				*
 *		routine. This may not be very portable as far as C goes				*
 *		but if you really want to write pascal it is a lot						*
 *		clearer than smart routines with pointers to unions of				*
 *		structures of resigstered unsigned ints. I am guessing				*
 *		that any DOS programmer can scramble together enough					*
 *		assembler to see what is happening here even if they					*
 *		have never met C before.														*
 *																								*
 ************************************************************************/

#include <stdio.h>
#include <bios.h>

void set_up(void)
{
	asm extrn   COMS_SET_UP_FAR:far
	asm call    COMS_SET_UP_FAR
}
int int14(int port, int ah, int al)
{
	_DX = port;		/* values into registers as Chapter 5 */
	_AH = ah;
	_AL = al;
	asm extrn   COMS_INT_14_FAR:far
	asm call    COMS_INT_14_FAR
	return _AX;
}
void unset_up(void)
{
	asm extrn   COMS_UNSET_FAR:far
	asm call    COMS_UNSET_FAR
}
/************************************************************************
 *									*
 * these are procedures to handle characters and strings.		*
 * I am not going to try and explain C strings as I don't think it will	*
 * really be relevant here.						*
 *									*
 ************************************************************************/

void coms_outchar(int port, char c)
{
	int14(port, 1, c);
}
int coms_inchar(int port)
{
	if(int14(port, 3, 0) & 0x0100)		/* test for Data AVailable */
		return int14(port, 2, 0) & 0x00ff;

	return -1;	/* if no data return -1 = 0xffff, an impossible char */
}
void coms_outstring(int port, char *s)
{
	char c;

	while((c=*s++)!=0)		/* while not terminator (=0) */
		coms_outchar(port, c);
}
void coms_instring(int port, char *s, int smax)
{
	int c;

	while(smax-->1 && (c=coms_inchar(port))!=-1)
		*s++ = c;
	*s=0;
}
/************************************************************************
 *									*
 * In C parlance main() is the procedure that actually gets called by	*
 * the .EXE file and it then calls those of the others it requires.	*
 *									*
 ************************************************************************/

void main()
{
	int c;

	printf("Hello world\n");

	set_up();		/* call the set_up procedure */

	int14(0, 0, 0x83);	/* set port to 83H = 1200baud no parity 8 bit */

	while(bioskey(1)==0)			/* loop till key is pressed */
		if((c=coms_inchar(0))!=-1)	/* if there is a byte ... */
			printf("%02X ", c);	/*  ... print it in hex */

	unset_up();		/* call the unset_up procedure */
	printf("\nAnd good-bye\n");
	bioskey(0);
}
